/*
Unreal Graphic Shader 1.0

Dev : Dimas Adiyaksa

Facebook : Dimas Adiyaksa
Fanspage Facebook : Unreal Graphic Shader PE
Instagram : @dimas.adiyaksa
Twitter : @dimasadiyaksa2
Discord : Dimas 956
*/

/*
=========== DONT STEAL ANYTHING !!! ==========
*/

#include "lib/Noise & Fbm.glsl"

float caustic_wave(vec3 p)
{
float wave = vnoise(p.xz * .1);
return clamp(pow(wave, 3.), 0., 1.);
}

vec3 caustic(vec3 pos, vec3 color)
{
   float wave = caustic_wave(pos);
   vec3 caustic_color = color * vec3(3.);
   vec3 out_color = color;
 
return mix(out_color, caustic_color, clamp(wave, 0., 1.));
}