/*
Unreal Graphic Shader 1.0

Dev : Dimas Adiyaksa

Facebook : Dimas Adiyaksa
Fanspage Facebook : Unreal Graphic Shader PE
Instagram : @dimas.adiyaksa
Twitter : @dimasadiyaksa2
Discord : Dimas 956
*/

/*
=========== DONT STEAL ANYTHING !!! ==========
*/

/*
Using Blinn Phong Specular
*/

vec4 Specular(vec3 pos)
{
   vec3 sun_pos = vec3(1000., 600., 0.);
   vec3 P = vec3(pos);
   vec3 Normal = normalize(pos);
   vec3 V = normalize(-P);
   vec3 L = normalize(sun_pos - P);
   vec3 H = normalize(V - L);
   vec4 Result = pow(max(0.0, dot(Normal, H)), 16.) * vec4(1.5);

return Result;
}

vec4 Ray_sun(vec3 pos)
{
   vec3 ray_pos = vec3(1000., 400., 0.);
   vec3 P = vec3(pos);
   vec3 Normal = normalize(pos);
   vec3 V = normalize(-P);
   vec3 Lsun = normalize(ray_pos - P);
   vec3 Hsun = normalize(V - Lsun);
   vec3 Result = pow(max(0.0, dot(Normal, Hsun)), 1.) *  vec3(.2);

return vec4(Result, 1.);
}