// __multiversion__
// This signals the loading code to prepend either #version 100 or #version 300 es as apropriate.

/*
Unreal Graphic Shader 1.0

Dev : Dimas Adiyaksa

Facebook : Dimas Adiyaksa
Fanspage Facebook : Unreal Graphic Shader PE
Instagram : @dimas.adiyaksa
Twitter : @dimasadiyaksa2
Discord : Dimas 956
*/

/*
=========== DONT STEAL ANYTHING !!! ==========
*/

#include "vertexVersionCentroidUV.h"

#include "uniformWorldConstants.h"
#include "uniformShaderConstants.h"

attribute POS4 POSITION;
attribute vec2 TEXCOORD_0;

varying vec3 pos;

void main()
{
    gl_Position = WORLDVIEWPROJ * POSITION;
    pos = POSITION.xyz;

    uv = (UV_TRANSFORM * vec4(TEXCOORD_0, 0, 1)).xy;
}