// __multiversion__
// This signals the loading code to prepend either #version 100 or #version 300 es as apropriate.

/*
Unreal Graphic Shader 1.0

Dev : Dimas Adiyaksa

Facebook : Dimas Adiyaksa
Fanspage Facebook : Unreal Graphic Shader PE
Instagram : @dimas.adiyaksa
Twitter : @dimasadiyaksa2
Discord : Dimas 956
*/

/*
=========== DONT STEAL ANYTHING !!! ==========
*/

#include "vertexVersionCentroidUV.h"

#include "uniformWorldConstants.h"

attribute POS4 POSITION;
attribute vec2 TEXCOORD_0;

varying highp vec3 pos;

void main()
{
    vec4 sun_pos = POSITION;
    sun_pos.xz *= 10.;
    sun_pos.x += .15;
    gl_Position = WORLDVIEWPROJ * sun_pos;
    pos = POSITION.xyz;

    uv = TEXCOORD_0;
}